export default Perser;

import { remark } from 'remark'
import remarkGfm from 'remark-gfm'
import remarkBreaks from "remark-breaks"
import remarkMath from 'remark-math'
import remarkRehype from 'remark-rehype'
import rehypeSlug from 'rehype-slug'
import rehypeKatex from 'rehype-katex'
import rehypeHighlight from 'rehype-highlight'
import rehypeExternalLinks from 'rehype-external-links'
import rehypeGithubAlert from 'rehype-github-alert'
import rehypeStringify from 'rehype-stringify'
import rehypeHeaderLinks from 'rehype-header-links'
import rehypeLazyImg from './rehypeLazyImg'


function Perser(mdtext: string): string {
    let md = remark()
        .use(remarkGfm)     // Github Markdown
        .use(remarkBreaks)  // 改行
        .use(remarkMath)    // 数式
        .use(remarkRehype, {allowDangerousHtml: true})
        .use(rehypeSlug)    // headingにidを設定
        .use(rehypeKatex, {output:'mathml'})    // 数式
        .use(rehypeLazyImg)
        .use(rehypeHighlight)   // Syntax highlight
        .use(rehypeExternalLinks, {target:'_blank', rel:['noreferrer','noopener']}) // 外部サイトを新規タブで開く
        .use(rehypeGithubAlert)
        .use(rehypeHeaderLinks,  {style: {color:'inherit'}})
        .use(rehypeStringify, {allowDangerousHtml: true})
        .processSync(mdtext)
        .toString()

    return md
}