import type { Root, RootContent } from 'hast'

export default function rehypeLazyImg() {
    return function(tree: Root) {
        function loop(children: RootContent[]){
            for (let child of children) {
                if (child.type == 'element' && child.tagName == 'img') {
                    child.properties.loading = 'lazy'
                }
                if ('children' in child) {
                    loop(child.children)
                }
            }
        }
        return loop(tree.children)
    }
}