export default parser; 

import yaml from "yaml"
import { parse } from '@twemoji/parser';
import { error } from '@sveltejs/kit';

function parser(fm_text:string) {

    let persed = yaml.parse(fm_text);

    let fms = (fm:unknown) => {
        if (typeof fm === 'object' && fm !== null){
            let title       = 'title' in fm       && typeof fm.title === 'string'      ? fm.title : ''
            let description = 'description' in fm && typeof fm.description === 'string'? fm.description : ''
            let thumbnail   = 'thumbnail' in fm   && typeof fm.thumbnail === 'string'  ? fm.thumbnail : ''
            let emoji       = 'emoji' in fm       && typeof fm.emoji === 'string'      ? fm.emoji : ''
            let date_str    = 'date' in fm        && typeof fm.date === 'string'       ? fm.date : ''
            let category    = 'category' in fm    && typeof fm.category === 'string'   ? fm.category : 'other'
            let tags        = 'tags' in fm        && Array.isArray(fm.tags)            ? fm.tags : []
            let index       = 'index' in fm       && typeof fm.index === 'boolean'     ? fm.index : true
            let published   = 'published' in fm   && typeof fm.published === 'boolean' ? fm.published : false

            emoji = parse(emoji, {buildUrl: builder})[0]?.url ?? ''

            function builder(codepoints: string, assetType: string): string {
                if (assetType == "png") {
                    return `https://moris.day/twemoji/72x72/${codepoints}.png`
                } else {
                    return `https://moris.day/twemoji/svg/${codepoints}.svg`
                }
            }

            let date:Date = new Date(date_str)

            return {title, description,thumbnail,emoji,date,category,tags,index,published}
        } else {
            error(500,{message:'Invalid frontmatter'})
        }
    }
    
    return fms(persed)
}