import Post from '$lib/server/LoadPost';
import Perser from '$lib/components/Markdown/Markdown'
import { remark } from 'remark'
import { visitParents } from 'unist-util-visit-parents'
import { toString } from 'mdast-util-to-string'
import GithubSlugger from 'github-slugger';

export interface tocitem {
    title: string,
    id: string,
    depth: 1 | 2 | 3 | 4 | 5 | 6
}

export async function load({params}) {
    const md = await Post(params.slug)
    let persed = Perser(md.post)

    let mdast = remark().parse(md.post)

    let headers: tocitem[] = []
    visitParents(mdast, 'heading', (node)=>{
        let slugs = new GithubSlugger()

        let title = toString(node)
        let id    = slugs.slug(title)
        let depth = node.depth

        let toc: tocitem = { title, id, depth }

        headers.push(toc)
    })

    return {
        id: params.slug,
        metadata: md.metadata,
        post: persed,
        toc: headers,
    }
}