export const prerender = true

import Metadatas from '$lib/server/Metadatas';
import { PUBLIC_HOSTNAME, PUBLIC_BASEPATH } from '$env/static/public';

/** @type {import('./$types').RequestHandler} */
export async function GET() {

    let items = ""
    let i = 0

    const metalist = await Metadatas()

    for (let post of metalist){

        let meta = post.metadata
        let link = `https://${PUBLIC_HOSTNAME}${PUBLIC_BASEPATH}/post/${post.postId}.md`

        i++
        items += `
        <item>
            <title>${meta.title}</title>
            <description>${meta.description}</description>
            <link>${link}</link>
            <pubDate>${meta.date.toUTCString()}</pubDate>
            <guid>${link}</guid>
        </item>`

        if (i==15) {break}
    }

    let rss = `<?xml version="1.0" encoding="UTF-8"?>
<rss version="2.0">
    <channel>
        <title>moris.day blog RSSfeed</title> 
        <description>工作とか化学とかプログラミングとか</description>
        <link>https://moris.day/blog</link>
        <pubDate>${(new Date()).toUTCString()}</pubDate>
        ${items}
    </channel>
</rss>`

    return new Response(rss);
};
